	.file "interrupt_asm.s"
	.section .iwram
	.arm
	.align
	.global irq_isr_dispatch_asm

	@ Register list:
	@ r0: isr function pointer
    @ r1: scratch for spsr
    @ r2: scratch for cpsr
	
irq_isr_dispatch_asm:

	@ Save SPSR and lr to the stack
	
	mrs r1, spsr
	stmfd sp!, {r1, lr}

	@ Hop into system mode, with IRQ enabled
	
	mrs r2, cpsr
	bic r2, r2, #0xDF 
	orr r2, r2, #0x1F
	msr cpsr, r2

	@ Call the ISR

	stmfd sp!, {lr}
	mov lr, pc
	bx r0
	ldmfd sp!, {lr}

	@ Back into IRQ mode, with IRQ disabled

	mrs r2, cpsr
	bic r2, r2, #0xDF
	orr r2, r2, #0x92
	msr cpsr, r2

	@ Restore SPSR and lr

	ldmfd sp!, {r1, lr}
	msr spsr, r1
	
	bx lr
