#include "tonc_types.h"
#include "tonc_memmap.h"
#include "tonc_memdef.h"
#include "sprite.h"
#include "math.h"


void init_sprites() {

	//move all sprites off screen (there is no disable flag)
	int i = 0;
	for (i = 0; i < 128; i++) {
		sprite_set(i, 241, 161, 0, 0, 0, 0);
	}
}

void sprite_set(u32 id,
				u32 xpos,
				u32 ypos,
				u16 sprite_number,
				u32 attr0_flags,
				u32 attr1_flags,
				u32 attr2_flags) {

	oam_mem[id].attr0 = attr0_flags | ypos;
	oam_mem[id].attr1 = attr1_flags | xpos;
	oam_mem[id].attr2 = attr2_flags | sprite_number;

}

void rotate_sprite_group(u32 id, s32 angle) {	
	obj_aff_mem[id].pa = cosf16(angle);
	obj_aff_mem[id].pb = -sinf16(angle);
	obj_aff_mem[id].pc = sinf16(angle);
	obj_aff_mem[id].pd = cosf16(angle);
}
