#pragma once

#include "tonc_types.h"

/**
 * Write text to the screen
 *
 * @param text - string to write
 * @param sbNum - screenblock number
 * @param paletteNum - palette number
 * @param x - x coordinate
 * @param y - y coordinate
 */
void text_write(const char* text, u32 sbNum, u32 paletteNum, u32 x, u32 y);

/**
 * Fill a region from x1,y1 to x2,y2, inclusive
 * 
 * @param sbNum - screenblock number
 * @param x1 - top left x coord
 * @param y1 - top left y coord
 * @param x2 - bottom right x coord
 * @param y2 - bottom right y coord 
 * @param paletteNum - palette number
 * @param fillChar - character to fill region with
 */
void text_clear(u32 sbNum,
					u32 x1,
					u32 y1,
					u32 x2,
					u32 y2,
					u32 paletteNum,
					const char fillChar);
