#!/usr/bin/env python2.7

import math

f = open('lut.c', 'w')


f.write('#include "tonc_types.h"\n')
f.write('typedef s16 f16;\n')
f.write('typedef s32 f32;\n')
f.write('\n')

f.write("const f16 SIN_LUT[] = {")

for i in range(0, 360):
	r = i*math.pi/180.0 
	s = math.sin(r)

	neg = 0
	if s < 0:
		neg = 0

	#s = math.fabs(s)
	s = s*256.0
	s_as_i = int(s)
	s_as_i |= (neg << 15)

	if i != 0:
		f.write(",")
	f.write(str(s_as_i))

f.write("};\n")

f.write("const f16 COS_LUT[] = {")

for i in range(0, 360):
	r = i*math.pi/180.0 
	s = math.cos(r)

	neg = 0
	if s < 0:
		neg = 0

	#s = math.fabs(s)
	s = s*256.0
	s_as_i = int(s)
	s_as_i |= (neg << 15)

	if i != 0:
		f.write(",")
	f.write(str(s_as_i))

f.write("};\n")

f.write("const s32 DIV_LUT[] = { 0xffffffff, ")

for i in range(1, 256):
	out = 1.0 / i
	out = out * (1 << 16)
	out_as_i = int(out)
	
	f.write(hex(out_as_i))
	if i != 255:
		f.write(", ")
	
f.write(" };\n")

f.close()

#header generation
f = open('lut.h', 'w')
f.write('extern const f16 SIN_LUT[];\n')
f.write('extern const f16 COS_LUT[];\n')
f.write('extern const s32 DIV_LUT[];\n')
f.close()
